<?php
/*
* Plugin Name: Hệ Thống Cửa Hàng
* Version: 1
* Description: Hệ Thống Cửa Hàng Thái Sơn
* Author: Nguyễn Thái Sơn

*/


define('NTS_URL', plugin_dir_path(__FILE__));

//add field setup
include ('inc/post_type_store_system.php');
include ('inc/shortcode.php');
//add style theme
add_action('wp_enqueue_scripts', function () {
    wp_enqueue_style('devvn-store-son-css', plugins_url('assets/css/devvn-store-son-css.css', __FILE__));
});

function custom_post_type_single_template($single_template) {
    if (is_singular('store_system')) {
        // Đường dẫn tới thư mục chứa tập tin single trong plugin
        $plugin_template_path = plugin_dir_path(__FILE__) . '/template/single-store_system.php';
        // Kiểm tra xem tập tin single tồn tại trong plugin hay không
        if (file_exists($plugin_template_path)) {
            return $plugin_template_path;
        }
    }
    // Nếu không tìm thấy tập tin single trong plugin, trả về tập tin single mặc định của theme
    return $single_template;
}
add_filter('single_template', 'custom_post_type_single_template');

if (!function_exists('wp_setup_theme')) {
    function wp_setup_theme()
    {
        register_sidebar([
            'id' => 'cua-hang-sidebar',
            'name' => __('Cửa hàng Sidebar'),
            'before_widget' => '<aside class="sale-widget">',
            'after_widget' => '</aside>'
        ]);
    }
    add_action('init', 'wp_setup_theme');
}

function custom_breadcrumb() {
    $delimiter = '<span class="breadcrumb-separator">/</span>';
    $home_text = 'Trang chủ';
    $before_link = '<span class="breadcrumb-current">';
    $after_link = '</span>';

    // Không hiển thị breadcrumb trên trang Trang chủ
    if (is_front_page()) return;

    echo '<div class="breadcrumb">';

    // Hiển thị link về trang chủ
    echo '<a href="' . get_home_url() . '">' . $home_text . '</a>' . $delimiter;

    if (is_category() || is_single()) {
        // Nếu là trang danh mục hoặc trang đơn lẻ (bài viết)
        the_category(' ' . $delimiter . ' ');
        if (is_single()) {
            echo $delimiter . $before_link . get_the_title() . $after_link;
        }
    } elseif (is_page()) {
        // Nếu là trang tĩnh
        global $post;
        if ($post->post_parent) {
            // Hiển thị link đến trang cha (nếu có)
            $parent_id  = $post->post_parent;
            $breadcrumbs = array();
            while ($parent_id) {
                $page = get_post($parent_id);
                $breadcrumbs[] = '<a href="' . get_permalink($page->ID) . '">' . get_the_title($page->ID) . '</a>';
                $parent_id  = $page->post_parent;
            }
            $breadcrumbs = array_reverse($breadcrumbs);
            foreach ($breadcrumbs as $crumb) {
                echo $crumb . ' ' . $delimiter . ' ';
            }
        }
        // Hiển thị tiêu đề của trang hiện tại
        echo $before_link . get_the_title() . $after_link;
    } elseif (is_author()) {
        // Nếu là trang tác giả
        global $author;
        $userdata = get_userdata($author);
        echo $before_link . 'Bài viết của ' . $userdata->display_name . $after_link;
    } elseif (is_404()) {
        // Nếu là trang 404 (không tìm thấy)
        echo $before_link . 'Không tìm thấy trang' . $after_link;
    }

    echo '</div>';
}















