<?php

function devvn_store_son()
{
    $posts_per_page = get_option('posts_per_page');
    $paged = get_query_var('paged', 1);
    $args = array(
        'hide_empty' => false,
        'taxonomy' => 'city_cat',
        'parent' => 0,
    );
    $list = get_categories($args);

    $query = new WP_Query(array(
        'paged' => $paged,
        'posts_per_page' => $posts_per_page,
        'post_type' => 'store_system',
        'post_status' => 'publish',
        'order' => 'DESC',
    ));
    ob_start();
    ?>
    <div class="loading" id="loader" style="display: none;"><span class="loader-wdes loader-double"></span></div>
    <article class="box-cd">
        <main class="city-page">
            <section class="city">
                <div class="container">
                    <div class="cau_hinh_c">
                        <div class="container">
                            <div class="row">
                                <div class="col medium-3 contactSidebarBox">
                                    <div class="contactSidebarBox_title">
                                        <?php
                                        echo get_option('store_system_option_title_sons', 'TÌM CỬA HÀNG THÁI SƠN');

                                        ?>
                                    </div>
                                    <select name="id_city" class="form-control "
                                            id="id_city">
                                        <option value="all">Tất cả cửa hàng</option>
                                        <?php foreach ($list as $cate) : ?>
                                            <option value=" <?php echo $cate->term_id ?>"> <?php echo $cate->name ?></option>
                                        <?php endforeach; ?>
                                    </select>

                                    <select name="id_district"
                                            class="form-control address-select"
                                            id="owen_district">
                                        <option value="">--- Chọn quận huyện ---</option>
                                    </select>
                                    <p class="contactResultSearchBox_title"><?php
                                        echo get_option('store_system_option_name_sons', 'Chào đón bạn ghé thăm:');
                                        ?></p>
                                    <div class="contactResultSearchBox_main">
                                        <ul>
                                            <?php
                                            while ($query->have_posts()): $query->the_post();
                                                ?>
                                                <li><a href="<?= get_the_permalink() ?>">
                                                        <svg
                                                                xmlns="http://www.w3.org/2000/svg"
                                                                fill="#000000"
                                                                width="24"
                                                                height="24"
                                                                viewBox="0 0 24 24"
                                                        >
                                                            <path d="M12 1.5C8.15 1.5 5 4.65 5 8.5c0 4.25 7 12.25 7 12.25s7-8 7-12.25c0-3.85-3.15-7-7-7zM7.05 8.5c0-2.08 1.7-3.78 3.78-3.78S14.6 6.42 14.6 8.5 12.9 12.28 10.83 12.28 7.05 10.58 7.05 8.5z"/>
                                                        </svg>
                                                        <?= get_post_meta(get_the_ID(), 'dia_chi', true) ?>
                                                    </a></li>

                                            <?php endwhile;
                                            ?>
                                        </ul>


                                    </div>


                                </div>
                                <div class="col medium-9">
                                    <div class="total_records"></div>

                                    <div class="idWriteContent row">

                                        <?php
                                        while ($query->have_posts()): $query->the_post();
                                            ?>
                                            <div id="col-182919091" class="col medium-4">
                                                <div class="col-inner">
                                                    <div class="post_city">
                                                        <div class="box-image">
                                                            <a href="<?= get_the_permalink() ?>">
                                                                <div class="image-zoom">
                                                                    <?php if (has_post_thumbnail(get_the_ID())): ?>
                                                                        <?= get_the_post_thumbnail(get_the_ID(), 'medium_large', array('alt' => get_the_title())) ?>
                                                                    <?php else: ?>
                                                                        <img src="<?= plugins_url('/no-images.png', __FILE__) ?>"
                                                                             alt="<?= the_title() ?>">
                                                                    <?php endif; ?>
                                                                    <div class="phone"><?= get_post_meta(get_the_ID(), 'dien_thoia', true) ?></div>
                                                                    <h2>
                                                                        <?php the_title() ?>
                                                                    </h2>
                                                                    <div class="gridStore_item_content__text">
                                                                        <?= get_post_meta(get_the_ID(), 'dia_chi', true) ?>
                                                                    </div>
                                                                </div>
                                                            </a>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        <?php endwhile;
                                        ?>
                                        <div class="col medium-12 noPadding">
                                            <div class="pagination"></div>
                                        </div>
                                    </div>

                                </div>


                            </div>

                        </div>
                    </div>
                </div>
            </section>
        </main>
    </article>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
        jQuery(document).ready(function ($) {
            $(window).on('load', function () {
                $.ajax({
                    type: "post", // Phương thức truyền post hoặc get
                    dataType: "json", // Dạng dữ liệu trả về xml, json, script, or html
                    url: '<?php echo admin_url('admin-ajax.php');?>', // Đường dẫn chứa hàm xử lý dữ liệu. Mặc định của WP như vậy
                    data: {
                        action: "thongbao", // Tên action
                        ategoryid: 'all', // Giá trị đã chọn từ phần tử có ID là 'id_city'
                    },
                    context: this,
                    beforeSend: function () {
                        // Làm gì đó trước khi gửi dữ liệu vào xử lý
                        $('#loader').show();
                    },
                    success: function (response) {
                        // Làm gì đó khi dữ liệu đã được xử lý
                        if (response.success) {
                            $('#loader').hide();

                            // Hiển thị dữ liệu kết quả lấy được từ response
                            $('.contactResultSearchBox_main').html(response.data['result']);
                            $('.idWriteContent').html(response.data['shop']);
                            $('.total_records').html(response.data['total_records']);

                            // Hiển thị danh sách quận huyện từ response
                            if (response.data['child_categories']) {
                                $html = '<option>--- Chọn quận huyện ---</option>';
                                $.each(response.data['child_categories'], function (index, element) {
                                    $html += '<option value="' + element.code + '">' + element.name + '</option>';
                                });
                                $('#owen_district').html($html);
                            }
                        } else {
                            alert('Đã có lỗi xảy ra');
                        }
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        // Làm gì đó khi có lỗi xảy ra
                        console.log('The following error occurred: ' + textStatus, errorThrown);
                    }
                });
                return false;

            });


            $(document).on('click', '#pageAjax ul li a', function (event) {
                event.preventDefault(); // Ngăn chặn hành vi mặc định của liên kết (chuyển trang)
                ajaxPage($(this)); // Gọi hàm ajaxPage và truyền liên kết được nhấn (this) làm đối số
            })


            $('#id_city').on('change', function () {
                var selectedCategoryId = $(this).val();
                console.log(selectedCategoryId);
                $.ajax({
                    type: "post", // Phương thức truyền post hoặc get
                    dataType: "json", // Dạng dữ liệu trả về xml, json, script, or html
                    url: '<?php echo admin_url('admin-ajax.php');?>', // Đường dẫn chứa hàm xử lý dữ liệu. Mặc định của WP như vậy
                    data: {
                        action: "thongbao", // Tên action
                        ategoryid: selectedCategoryId, // Giá trị đã chọn từ phần tử có ID là 'id_city'
                    },
                    context: this,
                    beforeSend: function () {
                        // Làm gì đó trước khi gửi dữ liệu vào xử lý
                        $('#loader').show();

                    },
                    success: function (response) {
                        // Làm gì đó khi dữ liệu đã được xử lý
                        if (response.success) {
                            $('#loader').hide();

                            // Hiển thị dữ liệu kết quả lấy được từ response
                            $('.contactResultSearchBox_main').html(response.data['result']);
                            $('.idWriteContent').html(response.data['shop']);


                            // Hiển thị danh sách quận huyện từ response
                            if (response.data['child_categories']) {
                                $html = '<option>--- Chọn quận huyện ---</option>';
                                $.each(response.data['child_categories'], function (index, element) {
                                    $html += '<option value="' + element.code + '">' + element.name + '</option>';
                                });
                                $('#owen_district').html($html);
                            }
                        } else {
                            alert('Đã có lỗi xảy ra');
                        }
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        // Làm gì đó khi có lỗi xảy ra
                        console.log('The following error occurred: ' + textStatus, errorThrown);
                    }
                });
                return false;
            });
            // Đoạn mã xử lý sự kiện khi thay đổi quận huyện (nếu cần)
            $('#owen_district').on('change', function () {
                var selectedDistrictId = $(this).val();
                console.log(selectedDistrictId);
                $.ajax({
                    type: "post", // Phương thức truyền post hoặc get
                    dataType: "json", // Dạng dữ liệu trả về xml, json, script, or html
                    url: '<?php echo admin_url('admin-ajax.php');?>', // Đường dẫn chứa hàm xử lý dữ liệu. Mặc định của WP như vậy
                    data: {
                        action: "thongbao", // Tên action
                        ategoryid: selectedDistrictId, // Giá trị đã chọn từ phần tử có ID là 'id_city'
                    },
                    context: this,
                    beforeSend: function () {
                        $('#loader').show();
                        // Làm gì đó trước khi gửi dữ liệu vào xử lý
                    },
                    success: function (response) {
                        // Làm gì đó khi dữ liệu đã được xử lý
                        if (response.success) {
                            $('#loader').hide();
                            // Hiển thị dữ liệu kết quả lấy được từ response
                            $('.contactResultSearchBox_main').html(response.data['result']);
                            $('.idWriteContent').html(response.data['shop']);


                            // Hiển thị danh sách quận huyện từ response

                        } else {
                            alert('Đã có lỗi xảy ra');
                        }
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        // Làm gì đó khi có lỗi xảy ra
                        console.log('The following error occurred: ' + textStatus, errorThrown);
                    }
                });
                return false;
            });
            // phan trang
            // Xử lý sự kiện khi liên kết phân trang được nhấn
            function ajaxPage(clickedLink) {
                // Lấy giá trị thuộc tính data-page của liên kết được nhấn (để biết trang cần tải)
                var pageToLoad = clickedLink.data('page');
                var name = $('#nametaxonomyson').val();
                // Thực hiện AJAX request
                $.ajax({
                    type: "post", // Phương thức truyền post hoặc get
                    dataType: "json", // Dạng dữ liệu trả về xml, json, script, or html
                    url: '<?php echo admin_url('admin-ajax.php');?>', // Đường dẫn chứa hàm xử lý dữ liệu. Mặc định của WP như vậy
                    data: {
                        action: "thongbao", // Tên action
                        ategoryid: name, // Giá trị đã chọn từ phần tử có ID là 'id_city'
                        page: pageToLoad, // Giá trị đã chọn từ phần tử có ID là 'id_city'
                    },
                    context: this,
                    beforeSend: function () {
                        // Làm gì đó trước khi gửi dữ liệu vào xử lý
                    },
                    success: function (response) {
                        // Làm gì đó khi dữ liệu đã được xử lý
                        if (response.success) {
                            // Hiển thị dữ liệu kết quả lấy được từ response
                            $('.contactResultSearchBox_main').html(response.data['result']);
                            $('.idWriteContent').html(response.data['shop']);


                        } else {
                            alert('Đã có lỗi xảy ra');
                        }
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        // Làm gì đó khi có lỗi xảy ra
                        console.log('The following error occurred: ' + textStatus, errorThrown);
                    }
                });
                return false;
            }
        });
    </script>

    <?php
    return ob_get_clean();
}

add_shortcode('devvn_store_son', 'devvn_store_son');


add_action('wp_ajax_thongbao', 'thongbao_init');
add_action('wp_ajax_nopriv_thongbao', 'thongbao_init');
function thongbao_init()
{

    ob_start(); // Bắt đầu bộ nhớ đệm
    $data = isset($_POST['ategoryid']) ? intval($_POST['ategoryid']) : 0;
    $posts_per_page = get_option('posts_per_page');
    $paged = isset($_POST['page']) ? $_POST['page'] : 1;
    $dataories = array();
    $result = '';
    $shop = '';

    if ($data) {
        $args_child = array(
            'taxonomy' => 'city_cat',
            'parent' => $data,
        );
        $child_categories = get_categories($args_child);
        foreach ($child_categories as $district) {
            $dataories[] = [
                'code' => $district->term_id,
                'name' => $district->name
            ];
        }
        $post_new = new WP_Query(array(
            'posts_per_page' => get_option('posts_per_page'),
            'paged' => $paged,
            'post_type' => 'store_system',
            'post_status' => 'publish',
            'order' => 'DESC',
            'tax_query' => array(
                array(
                    'taxonomy' => 'city_cat',
                    'field' => 'term_id',
                    'terms' => $data,
                ),
            ),
        ));

    }

    if ($data == 'all') {

        $post_new = new WP_Query(array(
            'posts_per_page' => get_option('posts_per_page'),
            'paged' => $paged,
            'post_type' => 'store_system',
            'post_status' => 'publish',
            'order' => 'DESC',

        ));
    }
    $total_records = $post_new->found_posts;
    $total_pages = ceil($total_records / $posts_per_page);
    // Xử lý dữ liệu danh sách bài viết
    $result = '<ul>'; // Thêm thẻ <ul> ở đây
    ob_start();
    while ($post_new->have_posts()) : $post_new->the_post();
        ?>
        <li><a href="<?= get_the_permalink() ?>">
                <svg
                        xmlns="http://www.w3.org/2000/svg"
                        fill="#000000"
                        width="24"
                        height="24"
                        viewBox="0 0 24 24"
                >
                    <path d="M12 1.5C8.15 1.5 5 4.65 5 8.5c0 4.25 7 12.25 7 12.25s7-8 7-12.25c0-3.85-3.15-7-7-7zM7.05 8.5c0-2.08 1.7-3.78 3.78-3.78S14.6 6.42 14.6 8.5 12.9 12.28 10.83 12.28 7.05 10.58 7.05 8.5z"/>
                </svg> <?= get_post_meta(get_the_ID(), 'dia_chi', true) ?>
            </a></li>
    <?php
    endwhile;
    $result .= ob_get_clean(); // Thêm nội dung từ ob_get_clean() vào biến $result
    $result .= '</ul>'; // Thêm thẻ đóng </ul> ở đây

    // Xử lý dữ liệu danh sách cửa hàng
    $shop = '';
    ob_start();
    while ($post_new->have_posts()) : $post_new->the_post();
        ?>
        <div id="col-182919091" class="col medium-4">

            <div class="col-inner">
                <div class="post_city">
                    <div class="box-image">
                        <a href="<?= get_the_permalink() ?>">
                            <div class="image-zoom">
                                <?php if (has_post_thumbnail(get_the_ID())): ?>
                                    <?= get_the_post_thumbnail(get_the_ID(), 'medium_large', array('alt' => get_the_title())) ?>
                                <?php else: ?>
                                    <img src="<?= plugins_url('/no-images.png', __FILE__) ?>"
                                         alt="<?= the_title() ?>">
                                <?php endif; ?>
                                <div class="phone"><?= get_post_meta(get_the_ID(), 'dien_thoia', true) ?></div>
                                <h2>
                                    <?php the_title() ?>
                                </h2>
                                <div class="gridStore_item_content__text">
                                    <?= get_post_meta(get_the_ID(), 'dia_chi', true) ?>
                                </div>
                            </div>
                        </a>
                    </div>
                </div>
            </div>
        </div>

    <?php
    endwhile;
    $shop = ob_get_clean();

    // Thêm phân trang vào biến $shop
    $shop .= '<div class="pagination" id="pageAjax">';
    $shop .= paginate_function($posts_per_page, $paged, $total_records, $total_pages);
    $shop .= '</div>';
    $shop .= '<td><input type="hidden" id="nametaxonomyson" name="name" value="' . $data . '"></td>';
    // Thêm dữ liệu vào response JSON
    wp_send_json_success(array(
        'child_categories' => $dataories,
        'result' => $result,
        'shop' => $shop,

    ));
    die(); // Bắt buộc phải có khi kết thúc
}

function paginate_function($item_per_page, $current_page, $total_records, $total_pages)
{
    $pagination = '';
    if ($total_pages > 0 && $total_pages != 1 && $current_page <= $total_pages) { //verify total pages and current page number
        $pagination .= '<ul class="page-numbers nav-pagination links text-center">';
        $right_links = $current_page + 3;
        $previous = $current_page - 3; //previous link
        $next = $current_page + 1; //next link
        $first_link = true; //boolean var to decide our first link
        if ($current_page > 1) {
            $previous_link = ($previous == 0) ? 1 : $previous;
            $pagination .= '<li><a href="#" data-page="' . $previous_link . '" title="Previous"><i class="icon-angle-left"></i></a></li>'; //previous link
            for ($i = ($current_page - 2); $i < $current_page; $i++) { //Create left-hand side links
                if ($i > 0) {
                    $pagination .= '<li><a href="#" data-page="' . $i . '" title="Page' . $i . '">' . $i . '</a></li>';
                }
            }
            $first_link = false; //set first link to false
        }
        if ($first_link) { //if current active page is first link
            $pagination .= '<li class="first active">' . $current_page . '</li>';
        } elseif ($current_page == $total_pages) { //if it's the last active link
            $pagination .= '<li class="last active">' . $current_page . '</li>';
        } else { //regular current link
            $pagination .= '<li class="active">' . $current_page . '</li>';
        }
        for ($i = $current_page + 1; $i < $right_links; $i++) { //create right-hand side links
            if ($i <= $total_pages) {
                $pagination .= '<li><a href="#" data-page="' . $i . '" title="Page ' . $i . '">' . $i . '</a></li>';
            }
        }
        if ($current_page < $total_pages) {
            $next_link = ($i > $total_pages) ? $total_pages : $i;
            $pagination .= '<li><a href="#" data-page="' . $next_link . '" title="Next"><i class="icon-angle-right"></i></a></li>'; //next link
        }
        $pagination .= '</ul>';
    }
    return $pagination; //return pagination links
}
